/*!
 * @file aiming_system.h
 *  Definition of
 */

#ifndef _AIMING_SYSTEM_H
#define _AIMING_SYSTEM_H

#include "p_node.h"
#include "element_2d.h"
#include "object_manager.h"

// FORWARD DECLARATION
class TiXmlElement;



class AimingSystem : public PNode
{

 public:
  AimingSystem(PNode* source, const TiXmlElement* root = NULL);
  virtual ~AimingSystem();

  void init();
  virtual void loadParams(const TiXmlElement* root);


  inline void selectTarget(PNode* target) { this->setParent(target); };
  inline PNode* getTarget(PNode* target) { return this->getParent(); };


  void setRange(float range){this->range = range;};
  void setAngle(float angle){this->angle = angle;};
  void setGroup(OM_LIST group){this->group = group;};


  virtual void tick(float dt);
  virtual void draw() const;

 private:
   Material*        material;             //!< a material for the AimingSystem.
   float            rotationSpeed;        //!< Speed of the Rotation.
   tAnimation<AimingSystem>* anim;

   float            range;                //!<
   float            angle;                //!<
   Vector           diffVec;
   OM_LIST          group;

};

#endif /* _AIMING_SYSTEM_H */
